import java.util.Random;
import java.util.Vector;
import java.util.Date;
import java.awt.*;

class Process
{
	private boolean Allocated;
	private int blockSize;
	private int Duration;
	private int executionTime;
	private int turnAroundTime;
      public int ProcessID;

    Process(int Size, int Time, int ID)
    {        
	  blockSize = Size;
        Duration = Time;
        ProcessID = ID;
        //System.out.println("Process #" + ProcessID + " was created");
    }

    public boolean updateState()
    {
        if(Allocated==true)
        {
            executionTime++;
            if(executionTime>Duration)
                return(true);
            else
                return(false);
        }
        else
        {
            turnAroundTime++;
		return(false);
        }
    }

    public void changeStatus()
    {
        Allocated = true;
        //System.out.println("Process #" + ProcessID + " was allocated");
    }

    public boolean getAllocStatus()
    {
        return Allocated;
    }

    public int getDuration()
    {
        return Duration;
    }

    public int getBlockSize()
    {
        return blockSize;
    }

    public int getTurnAroundTime()
    {
        return turnAroundTime;
    }

}

//******************************************************************//

class ProcessManager
{
    Vector activeList = new Vector();
    Vector suspendedList = new Vector();
    private int creationTime;
    private int Time;
    private int absTime;	
    Date d = new Date();
    //Random r = new Random(d.getTime());
    Random r = new Random(1);	
    Free_suspended SuspendedStatus = new Free_suspended("Suspend Processes","Process No.","Block Size","Turnaround Time");	
    AllocationManager AM = new AllocationManager();
    public plog processlog;
    private int globalID;
    public double avgTurnAround;
    public double Accumulate;
		
    ProcessManager()
    {
        creationTime = Math.abs(r.nextInt()%10) + 1;
	  SuspendedStatus.setVisible(true);
	  SuspendedStatus.setLocation(70,70);	
	  processlog = new plog();
	  processlog.setVisible(true);
	  processlog.setLocation(30,30);		
    }

    public void updateTime(int Scheme)
    {
        Process newProcess;
        int Size, Duration;

	  Time++;
	  absTime++;
        if(Time>creationTime)
        {
                Time = 0;
                creationTime = Math.abs(r.nextInt()%10) + 1;
                Size = 50 + 10*(Math.abs(r.nextInt()%25)+1);
		    Duration = 5 + 5 * (Math.abs(r.nextInt()%11) + 1);
		    newProcess = new Process(Size, Duration, globalID++);
		   // processlog.update_field("Time " + absTime + ":Process #" + newProcess.ProcessID + "(" + 
			//			    Duration + "," + Size + ")" + " was created" + "\n"); 
                suspendedList.addElement(newProcess);
       }
       updateActiveList();
       updateSuspendedList(Scheme);
	// printSuspendedList();
	 if(globalID!=0)
		 avgTurnAround = Accumulate/globalID;
   }

    private void updateSuspendedList(int Scheme)
    {
         int Index;
         Process Element;
	   boolean Status = false;	
         for(Index=0;Index<suspendedList.size();Index++)
         {
            Element = (Process)suspendedList.elementAt(Index);
		switch(Scheme)
		{
			case 1: 
			Status = AM.allocateFirstFit(Element); 
			break;

			case 2: 
			Status = AM.allocateBestFit(Element); 
			break;

			case 3: 
			Status = AM.allocateWorstFit(Element); 
			break;

			case 4: 
			Status = AM.allocateNextFit(Element); 
			break;
		}

		if(Status==true)
            {
                suspendedList.removeElementAt(Index);
                Element.changeStatus();
                Index--;
                activeList.addElement(Element);
		    //processlog.update_field("Time " + absTime + ":Process #" + Element.ProcessID + 
		     //                       "(" + Element.getTurnAroundTime() + ")" + " was allocated"+"\n");	
            }
            else
		{
                Element.updateState();
		    Accumulate++;
		}	
         }
   //      AM.printFreeList();
       //  AM.printUsedList();
    }

    private void updateActiveList()
    {
        int Index;
        Process Element;

        for(Index=0; Index<activeList.size();Index++)
        {
            Element = (Process)activeList.elementAt(Index);
            if(Element.updateState())
            {
                activeList.removeElementAt(Index);
                Index--;
                AM.Deallocate(Element);
		   // processlog.update_field("Time " + absTime + ":Process #" + Element.ProcessID + " was deallocated"+"\n");		
            }
        }
    }

    void printSuspendedList()
    {        
	  //System.out.println("******************Suspended Processes Status*********************");
        SuspendedStatus.clearArea();
	  for(int i=0; i<suspendedList.size(); i++)
        {
            //System.out.println("Process#:" + ((Process)suspendedList.elementAt(i)).ProcessID + " Block size:" + ((Process)suspendedList.elementAt(i)).getBlockSize());
		//SuspendedStatus.update_field(((Process)suspendedList.elementAt(i)).ProcessID + "\n", ((Process)suspendedList.elementAt(i)).getBlockSize() + "\n", ((Process)suspendedList.elementAt(i)).getTurnAroundTime() + "\n");
        }
    }
    
    double getSU()
    {
	 int memUsed = AM.getMemUsed();
	 return((double)memUsed/(double)1536*100);
    }			
}

class freeNode
{
    public long Address;
    public int blockSize;

    freeNode(long A, int b)
    {
        Address = A;
        blockSize = b;
    }
}

class usedNode
{
    public long Address;
    public int blockSize;
    public int ProcessID;

    usedNode(long A, int b, int P)
    {
        Address = A;
        blockSize = b;
        ProcessID = P;
    }
}

class AllocationManager
{
    Vector usedList = new Vector();
    Vector freeList = new Vector();
    Free_suspended memoryStatus = new Free_suspended("Free Memory","Address","Block Size","Status");
    Free_suspended allocatedStatus = new Free_suspended("Allocated Process","Process No.","Address","Block Size"); 
    int memUsed; 	
    int mIndex;
	
    AllocationManager()
    {
        freeNode Node = new freeNode(0x4B000L, 1236);
        freeList.addElement(Node);
	  memoryStatus.setVisible(true);
 	  allocatedStatus.setVisible(true);
    }

    boolean allocateFirstFit(Process P)
    {
        int Index;
        int totElements = freeList.size();
        int reqSize = P.getBlockSize();
        int ID = P.ProcessID;
        freeNode Node;
     	  usedNode Element;

        for(Index=0;Index<totElements;Index++)
        {
            Node = (freeNode)freeList.elementAt(Index);
            if(Node.blockSize >= reqSize)
            {
                freeList.removeElementAt(Index);
                Element = new usedNode(Node.Address, reqSize, ID);
                usedList.addElement(Element);
                Node.blockSize = Node.blockSize - reqSize;
                if(Node.blockSize>0)
                {
                    Node.Address = Node.Address + (reqSize*1024);
                    freeList.insertElementAt(Node, Index);
                }
                return(true);
            }
        }
        return(false);
    }

    boolean allocateWorstFit(Process P)
    {
    	int WorstBlock=((freeNode)freeList.elementAt(0)).blockSize;
	int WorstIndex=0;
	int i;

	for(i=0; i<freeList.size(); i++)
	{
		if(WorstBlock < ((freeNode)freeList.elementAt(i)).blockSize)
		{
			WorstBlock = ((freeNode)freeList.elementAt(i)).blockSize;
			WorstIndex = i;
		}
	}
	//now check if the index found is really valid
	//now get the freenode at the index found, modify it and then re-insert it.  Also, insert
	// a new node in the used list.
	if(((freeNode)freeList.elementAt(WorstIndex)).blockSize < P.getBlockSize())
		return(false);
	
	freeNode theNode = (freeNode)freeList.elementAt(WorstIndex);
	usedList.addElement(new usedNode(theNode.Address, P.getBlockSize(), P.ProcessID)); 
	theNode.blockSize = theNode.blockSize - P.getBlockSize();
	if(theNode.blockSize>0)
	{
		theNode.Address = theNode.Address + (P.getBlockSize()*1024);
		freeList.setElementAt(theNode,WorstIndex);
	}
	else
		freeList.removeElementAt(WorstIndex);

	return(true);
    }

    boolean allocateBestFit(Process P)
    {
    	int BestBlock=((freeNode)freeList.elementAt(0)).blockSize;
	int BestIndex=0;
	int i;
	
	while(BestIndex < freeList.size() && P.getBlockSize()>((freeNode)freeList.elementAt(BestIndex)).blockSize)
		BestIndex++;

	if(!(BestIndex < freeList.size()))
		return(false);

	for(i=BestIndex; i<freeList.size(); i++)
	{
		if(BestBlock > ((freeNode)freeList.elementAt(i)).blockSize && 
	         P.getBlockSize()<=((freeNode)freeList.elementAt(i)).blockSize)
		{
			BestBlock = ((freeNode)freeList.elementAt(i)).blockSize;
			BestIndex = i;
		}
	}
	//now check if the index found is really valid
	//now get the freenode at the index found, modify it and then re-insert it.  Also, insert
	// a new node in the used list.
	if(((freeNode)freeList.elementAt(BestIndex)).blockSize < P.getBlockSize())
		return(false);
	
	freeNode theNode = (freeNode)freeList.elementAt(BestIndex);
	usedList.addElement(new usedNode(theNode.Address, P.getBlockSize(), P.ProcessID)); 
	theNode.blockSize = theNode.blockSize - P.getBlockSize();
	if(theNode.blockSize>0)
	{
		theNode.Address = theNode.Address + (P.getBlockSize()*1024);
		freeList.setElementAt(theNode,BestIndex);
	}
	else
		freeList.removeElementAt(BestIndex);

	return(true);
    }
	
    void Deallocate(Process P)
    {
        int Index=0;
        int totElements = usedList.size();
        boolean Found=false;
        usedNode Element;
        freeNode Node = new freeNode(0,0);
        long Address=0;
  	  int freeBlkSize=0;
        //System.out.println("Process #" + P.ProcessID + " was deallocated");
	
        while(Index<totElements && !Found)
        {
            Element = (usedNode)usedList.elementAt(Index);

            if(Element.ProcessID == P.ProcessID)
            {
                Address = Element.Address;
		    freeBlkSize = Element.blockSize;
                usedList.removeElementAt(Index);
                Found = true;
            }
            else
                Index++;
        }

        if(!Found)
            return;

        totElements = freeList.size();
        Index = 0;
        Found = false;
//        int freeBlkSize = P.getBlockSize();
	

        if(freeList.isEmpty())
            freeList.addElement(new freeNode(Address, freeBlkSize));
        else
        {
            while(Index<totElements && !Found)
            {
                Node = (freeNode)freeList.elementAt(Index);
                if(Node.Address > Address)
                    Found = true;
                else
                    Index++;
            }

            if(Index==0)
            {
                if((Address+freeBlkSize*1024) == Node.Address)
                {
                    Node.Address = Address;
                    Node.blockSize += freeBlkSize;
                    freeList.setElementAt(Node, Index);
                }
                else
                    freeList.insertElementAt(new freeNode(Address,freeBlkSize),Index);
            }
            else if(Index==totElements)
            {
                if((Node.Address+Node.blockSize*1024) == Address)
                {
                    Node.blockSize += freeBlkSize;
                    freeList.setElementAt(Node, Index-1);
                }
                else
                    freeList.addElement(new freeNode(Address, freeBlkSize));
            }
            else
            {
                freeNode pNode = (freeNode)freeList.elementAt(Index-1);
                if((pNode.Address  + pNode.blockSize*1024) == Address && (Address + freeBlkSize*1024) == Node.Address)
                {
                    pNode.blockSize = pNode.blockSize + freeBlkSize + Node.blockSize;
                    freeList.setElementAt(pNode, Index-1);
                    freeList.removeElementAt(Index);
                }
                else if((Address+freeBlkSize*1024) == Node.Address)
                {
                    Node.Address = Address;
                    Node.blockSize += freeBlkSize;
                    freeList.setElementAt(Node, Index);
                }
                else if((pNode.Address+pNode.blockSize*1024) == Address)
                {
                    pNode.blockSize += freeBlkSize;
                    freeList.setElementAt(pNode, Index-1);
                }
                else
                    freeList.insertElementAt(new freeNode(Address, freeBlkSize), Index);
            }
        }
    }

    void printFreeList()
    {
        //System.out.println("******************Free Memory Status*********************");
	  memoryStatus.clearArea();
        for(int i=0; i<freeList.size(); i++)
        {
            //System.out.println("Address:" + ((freeNode)freeList.elementAt(i)).Address + " Block size:" + ((freeNode)freeList.elementAt(i)).blockSize);
		memoryStatus.update_field(((freeNode)freeList.elementAt(i)).Address + "\n", ((freeNode)freeList.elementAt(i)).blockSize + "\n", "Free\n");
        }
    }

    void printUsedList()
    {
        //System.out.println("******************Allocation Status*********************");
        allocatedStatus.clearArea();
	  for(int i=0; i<usedList.size(); i++)
        {
            //System.out.println("Process#" + ((usedNode)usedList.elementAt(i)).ProcessID + " Address:" + ((usedNode)usedList.elementAt(i)).Address + " Block size:" + ((usedNode)usedList.elementAt(i)).blockSize);
		allocatedStatus.update_field(((usedNode)usedList.elementAt(i)).ProcessID + "\n", ((usedNode)usedList.elementAt(i)).Address + "\n", ((usedNode)usedList.elementAt(i)).blockSize + "\n");
        }
    }
	
    int getMemUsed()
    {
	  memUsed = 0;
	  for(int i=0; i<usedList.size(); i++)
        {           
		memUsed += ((usedNode)usedList.elementAt(i)).blockSize;
        }
	  memUsed = memUsed  + 300;
	  return(memUsed);
    }

    boolean allocateNextFit(Process P)
    {
	  int oldIndex;
        int totElements = freeList.size();
        int reqSize = P.getBlockSize();
        int ID = P.ProcessID;
        freeNode Node;
	  usedNode Element;
 
	  boolean notFound=false;
		
	  oldIndex = mIndex;

	  while(!notFound && mIndex<freeList.size())
        {
            Node = (freeNode)freeList.elementAt(mIndex);
            if(Node.blockSize >= reqSize)
            {
                freeList.removeElementAt(mIndex);                               
                Node.blockSize = Node.blockSize - reqSize;
                if(Node.blockSize>50)
                {
        		  Element = new usedNode(Node.Address, reqSize, ID);			
                    Node.Address = Node.Address + (reqSize*1024);
                    freeList.insertElementAt(Node, mIndex);
                }
		    else 
			  Element = new usedNode(Node.Address, reqSize+Node.blockSize, ID);			
	    
		    if(!(mIndex<freeList.size()))
			mIndex=0;	

		    usedList.addElement(Element);		
                return(true);
            }
		else
		{
		    mIndex++;
		    if(!(mIndex<freeList.size()))
			mIndex=0;	
		    if(oldIndex==mIndex)
			notFound = true;	
		}
        }
	  if(mIndex>=freeList.size())
		mIndex = 0;	
        return(false);
    }
		
}

class Simulation
{
    public int Time;
    ProcessManager PM = new ProcessManager();
    mainframe ControlPanel = new mainframe("Simulation of Placement Policies"); 	
    public static boolean runFlag;	    
    private plog Statistics = new plog();
	
    private void triggerEvents(int Scheme)
    {
        Time++;
        PM.updateTime(Scheme);
    }
    
	private void Delay(long Duration)
	{
		for(long i=0;i<Duration;i++)
		{ }
	}

    public static void main(String args[])
		throws java.io.IOException
    {
        Simulation simObject= new Simulation();
        char c;		   
	  simObject.ControlPanel.setVisible(true);
	  simObject.Statistics.setVisible(true);
	  simObject.Statistics.setLocation(30,30);
//      while((c=(char)System.in.read())!='\n')
	  while(true)	
        {
            if(Simulation.runFlag==true)
		{
			//System.out.println("\nSimulation time:"+ firstFit.Time);
			//simObject.Delay(1000);
      	      simObject.triggerEvents(2);
			//simObject.ControlPanel.update_status("Simulation Time: " + simObject.Time + "   Avg. Turnaround Time: " 
				//	          + simObject.PM.avgTurnAround + "   Storage Utilization: " + simObject.PM.getSU());
			if(simObject.Time%100 == 0)
			simObject.Statistics.update_field(simObject.Time + "," + simObject.PM.avgTurnAround + "," + 
				                           simObject.PM.getSU() + "\n"); 

		}

        }
    }
}
